/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef _BUDDYMODEL_H
#define _BUDDYMODEL_H

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif

#include <gtkmm.h>
#include <iostream>

class CellRendererIcon : public Gtk::CellRendererPixbuf
{
public:
	CellRendererIcon() 
	{
		property_xalign() = 0.0;
		property_ypad() = 0;
	}
};

class CellRendererNick : public Gtk::CellRendererText
{
public:
	CellRendererNick() 
	{
		property_ypad() = 0;
		property_yalign() = 0.5;
	}
};


class BuddyColumnModel : public Gtk::TreeModel::ColumnRecord
{
public:
	BuddyColumnModel()
	{ 
		add(nick);
		add(icon); 
		add(icon_visible);
		
		add(id);
		add(groupnum); 
		add(status);
	}
	
	Gtk::TreeModelColumn<std::string> id;
	Gtk::TreeModelColumn<int> status;
	Gtk::TreeModelColumn<int> groupnum;
	
	Gtk::TreeModelColumn<std::string> nick;
	Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> >  icon;
	Gtk::TreeModelColumn<bool> icon_visible;
	
};

typedef struct __buddy_info BuddyInfo;
	
struct __buddy_info {
	unsigned int listnum; //allow, block, forward, reverse
	unsigned int groupnum;
	std::string id;
	std::string nick;
	unsigned int status;
	std::string msobj;
};	

typedef struct __group_info GroupInfo;
	
struct __group_info {
	std::string groupname;
	Gtk::TreeIter iter;
};	

#endif /* _BUDDYMODEL_H */
