/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "ChatWindow.h"

#include <gdk/gdkkeysyms.h>
#include <gdkmm/pixbufloader.h>
#include <gtkmm/imagemenuitem.h>
#include <gtk/gtkimagemenuitem.h>
#include <gtkmm/menuitem.h>
#include <gtkmm/menu.h>
#include <gtkmm/menubar.h>
#include <gtkmm/textview.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/image.h>
#include <gtkmm/table.h>
#include <gtkmm/label.h>
#include <gtkmm/box.h>
#include <gtkmm/alignment.h>
#include <gtkmm/button.h>
#include <gtkmm/buttonbox.h>
#include <gtk/gtk.h>
#include "global.h"

ChatWindow::ChatWindow(const std::string& _buddyid) :
	buddyid(_buddyid),
	chatconnection(false), 
	is_offline(false),
	is_invitewindow(false)
{
	m_msgIdentifier=0;
	m_sessionId=0;
	m_totalDataSize=0;
	m_offset=0;
	Gtk::ImageMenuItem *_________________n_1 = NULL;
	Gtk::ImageMenuItem *_______o_1 = NULL;
	Gtk::ImageMenuItem *_______s_1 = NULL;
	Gtk::ImageMenuItem *___________________________a_1 = NULL;
	Gtk::MenuItem *separatormenuitem1 = NULL;
	Gtk::ImageMenuItem *__________q_1 = NULL;
	Gtk::Menu *menu1 = Gtk::manage(new class Gtk::Menu());
	Gtk::MenuItem *menuitem1 = NULL;
	Gtk::ImageMenuItem *_____________t_1 = NULL;
	Gtk::ImageMenuItem *_______c_1 = NULL;
	Gtk::ImageMenuItem *______________p_1 = NULL;
	Gtk::ImageMenuItem *__________d_1 = NULL;
	Gtk::Menu *menu2 = Gtk::manage(new class Gtk::Menu());
	Gtk::MenuItem *menuitem2 = NULL;
	Gtk::Menu *menu3 = Gtk::manage(new class Gtk::Menu());
	Gtk::MenuItem *menuitem3 = NULL;
	Gtk::MenuItem *about1 = NULL;
	Gtk::Menu *menu4 = Gtk::manage(new class Gtk::Menu());
	Gtk::MenuItem *menuitem4 = NULL;
	Gtk::MenuBar *menubar1 = Gtk::manage(new class Gtk::MenuBar());
	
	textbuffer = Gtk::TextBuffer::create();
	text = Gtk::manage(new class Gtk::TextView(textbuffer));
	textbuffer->set_text("This conversion is NOT secret.\r\n\r\n");
	Gtk::ScrolledWindow *scrolledwindow1 = Gtk::manage(new class Gtk::ScrolledWindow());
	
	//TODO :
	//
	// read ms pic.
	Glib::RefPtr<Gdk::Pixbuf> _image2_loader= Gdk::Pixbuf::create_from_file(pixmap_dir("day.jpg"));
	Gtk::Image *image2 = Gtk::manage(new class Gtk::Image());
	
	Gtk::Button *button1 = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-select-font")));
	Gtk::Button *button2 = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-select-color")));
	Gtk::Button *button3 = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-convert")));
	Gtk::Button *button4 = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-select-color")));
		
	Gtk::HButtonBox *hbuttonbox1 = Gtk::manage(new class Gtk::HButtonBox(Gtk::BUTTONBOX_START, 0));
	
	entrybuffer = Gtk::TextBuffer::create();
	entry = Gtk::manage(new class Gtk::TextView(entrybuffer));
	
	Glib::RefPtr<Gdk::Pixbuf> _image1_loader= Gdk::Pixbuf::create_from_file(pixmap_dir("day.jpg"));
	Gtk::Image *image1 = Gtk::manage(new class Gtk::Image(_image1_loader));
		
	Gtk::Table *table1 = Gtk::manage(new class Gtk::Table(2, 2, false));
	Gtk::VBox *vbox1 = Gtk::manage(new class Gtk::VBox(false, 0));
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-new")));
	_________________n_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-open")));
	_______o_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-save")));
	_______s_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-save-as")));
	___________________________a_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::SeparatorElem());
	separatormenuitem1 = (Gtk::MenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-quit")));
	__________q_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu2->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-cut")));
	_____________t_1 = (Gtk::ImageMenuItem *)&menu2->items().back();
	
	menu2->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-copy")));
	_______c_1 = (Gtk::ImageMenuItem *)&menu2->items().back();
	
	menu2->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-paste")));
	______________p_1 = (Gtk::ImageMenuItem *)&menu2->items().back();
	
	menu2->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-delete")));
	__________d_1 = (Gtk::ImageMenuItem *)&menu2->items().back();
	
	menu4->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_About")));
	about1 = (Gtk::MenuItem *)&menu4->items().back();
	
	menubar1->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_File"), *menu1));
	menuitem1 = (Gtk::MenuItem *)&menubar1->items().back();
	
	menubar1->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_Edit"), *menu2));
	menuitem2 = (Gtk::MenuItem *)&menubar1->items().back();
	
	menubar1->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_View"), *menu3));
	menuitem3 = (Gtk::MenuItem *)&menubar1->items().back();
	
	menubar1->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_Help"), *menu4));
	menuitem4 = (Gtk::MenuItem *)&menubar1->items().back();
	text->set_flags(Gtk::CAN_FOCUS);
	text->set_editable(false);
	text->set_cursor_visible(false);
	text->set_pixels_above_lines(0);
	text->set_pixels_below_lines(0);
	text->set_pixels_inside_wrap(0);
	text->set_left_margin(0);
	text->set_right_margin(0);
	text->set_indent(0);
	text->set_wrap_mode(Gtk::WRAP_CHAR);
	text->set_justification(Gtk::JUSTIFY_LEFT);
	scrolledwindow1->set_flags(Gtk::CAN_FOCUS);
	scrolledwindow1->set_shadow_type(Gtk::SHADOW_NONE);
	scrolledwindow1->set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS);
	scrolledwindow1->property_window_placement().set_value(Gtk::CORNER_TOP_LEFT);
	scrolledwindow1->add(*text);
	image2->set_alignment(0.5,0.5);
	image2->set_padding(0,0);
	button1->set_flags(Gtk::CAN_FOCUS);
	button1->set_relief(Gtk::RELIEF_NONE);
	button2->set_flags(Gtk::CAN_FOCUS);
	button2->set_relief(Gtk::RELIEF_NONE);
	button3->set_flags(Gtk::CAN_FOCUS);
	button3->set_relief(Gtk::RELIEF_NONE);
	button4->set_flags(Gtk::CAN_FOCUS);
	button4->set_relief(Gtk::RELIEF_NONE);
	hbuttonbox1->pack_start(*button1);
	hbuttonbox1->pack_start(*button2);
	hbuttonbox1->pack_start(*button3);
	hbuttonbox1->pack_start(*button4);
	entry->set_flags(Gtk::CAN_FOCUS);
	entry->set_editable(true);
	entry->set_cursor_visible(true);
	entry->set_pixels_above_lines(0);
	entry->set_pixels_below_lines(0);
	entry->set_pixels_inside_wrap(0);
	entry->set_left_margin(0);
	entry->set_right_margin(0);
	entry->set_indent(0);
	entry->set_wrap_mode(Gtk::WRAP_CHAR);
	entry->set_justification(Gtk::JUSTIFY_LEFT);
	entry->set_size_request(200,80);
	
	image1->set_alignment(0.5,0);
	image1->set_padding(0,0);
	table1->set_row_spacings(0);
	table1->set_col_spacings(0);
	table1->attach(*scrolledwindow1, 0, 1, 0, 1, Gtk::EXPAND|Gtk::FILL, Gtk::EXPAND|Gtk::FILL, 0, 0);
	table1->attach(*image2, 1, 2, 2, 3, Gtk::AttachOptions(), Gtk::AttachOptions(), 0, 0);
	table1->attach(*hbuttonbox1, 0, 1, 1, 2, Gtk::FILL, Gtk::AttachOptions(), 0, 0);
	table1->attach(*entry, 0, 1, 2, 3, Gtk::FILL, Gtk::FILL, 0, 0);
	table1->attach(*image1, 1, 2, 0, 1, Gtk::AttachOptions(), Gtk::FILL, 9, 9);
	vbox1->pack_start(*menubar1, Gtk::PACK_SHRINK, 0);
	vbox1->pack_start(*table1);
	this->set_title(_("chat"));
	this->set_modal(false);
	this->property_window_position().set_value(Gtk::WIN_POS_NONE);
	this->set_resizable(true);
	this->property_destroy_with_parent().set_value(false);
	this->set_default_size(400, 400);
	this->add(*vbox1);
	_________________n_1->show();
	_______o_1->show();
	_______s_1->show();
	___________________________a_1->show();
	separatormenuitem1->show();
	__________q_1->show();
	menuitem1->show();
	_____________t_1->show();
	_______c_1->show();
	______________p_1->show();
	__________d_1->show();
	menuitem2->show();
	menuitem3->show();
	about1->show();
	menuitem4->show();
	menubar1->show();
	text->show();
	scrolledwindow1->show();
	image2->show();
	button1->show();
	button2->show();
	button3->show();
	button4->show();
	hbuttonbox1->show();
	entry->show();
	image1->show();
	table1->show();
	vbox1->show();
	/*
	_________________n_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on__________________n_1_activate));
	_______o_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on________o_1_activate));
	_______s_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on________s_1_activate));
	___________________________a_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on____________________________a_1_activate));
	__________q_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on___________q_1_activate));
	_____________t_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on______________t_1_activate));
	_______c_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on________c_1_activate));
	______________p_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on_______________p_1_activate));
	__________d_1->signal_activate().connect(SigC::slot(*this, &window1_glade::on___________d_1_activate));
	about1->signal_activate().connect(SigC::slot(*this, &window1_glade::on_about1_activate));
	*/
	
	
	
	entry->signal_button_press_event().connect(
		SigC::slot(*this, &ChatWindow::on_entry_button_press_event)
		, true);
	
	entry->signal_key_press_event().connect(
		SigC::slot(*this, &ChatWindow::on_entry_key_press_event)
		, false);
	entry->grab_focus();
	button3->signal_clicked().connect(SigC::slot(*this, &ChatWindow::on_invite_clicked));	
	this->signal_delete_event().connect(SigC::bind<const std::string>(SigC::slot(*mainwindow, &MainWindow::on_chatwindow_delete_event), buddyid));
}

ChatWindow::~ChatWindow()
{
	std::cout << buddyid << " chatwindow deleted" << std::endl;
	//send goodbye
}
void
ChatWindow::on_invite_clicked()
{
	if (!is_invitewindow) {
		invitewindow = new InviteWindow(sockchannel, onsessionbuddylist);
		is_invitewindow = true;
	}
	invitewindow->show();
}
bool
ChatWindow::on_entry_button_press_event(GdkEventButton* event)
{
	return true;
}
bool
ChatWindow::on_entry_key_press_event(GdkEventKey* event)
{

	gboolean im_context_retval = FALSE;
	static guint32 last_event_time;
		
	if (last_event_time != event->time) {
		im_context_retval = gtk_im_context_filter_keypress(GTK_TEXT_VIEW(entry->gobj())->im_context, event);
	}
	last_event_time = event->time;
	if (im_context_retval == TRUE) {
		return TRUE;
	}

	if (event->keyval == GDK_Return || event->keyval == GDK_KP_Enter) {
		if (event->state & GDK_MOD1_MASK || event->state & GDK_SHIFT_MASK || event->state & GDK_CONTROL_MASK ) {
			entrybuffer->insert_at_cursor("\n");
			return true;
		}
		std::string entrytext = entrybuffer->get_text();
		char buf[MSN_MAX_BUF_LEN];
		sprintf(buf,"MIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\nUser-Agent: Fmsn/0.3\r\nX-MMS-IM-Format: FN=MS%%20Sans%%20Serif; EF=; CO=0; PF=0\r\n\r\n%s", entrytext.c_str());
		if (chatconnection) {
			sockchannel->sendCommand("MSG  N %d\r\n%s", strlen(buf), buf);
		}
		else {
			// send XFR SB to make chat connection if messagequeue is empty
			if (messagequeue.empty() || is_offline) // if not connected yet.
				mainwindow->registchatwaitlist(buddyid);
			messagequeue.push(buf);
		}
		entrybuffer->set_text("");
		std::string str = url_decode(userinfo.nick);
		str += " say :\r\n     ";
		str += entrytext;
		str += "\r\n";
		Gtk::TextBuffer::iterator iter = textbuffer->end();
		iter = textbuffer->insert(iter, str);
		textmark = textbuffer->create_mark(iter);
		text->scroll_to_mark(textmark, 0.0, 0.0, 1.0);

		return true;
	}
	return false;
}

void 
ChatWindow::request_display_picture(const std::string& object)
{
	std::string msobj;
	m_sessionId = 0;
	
	msobj = b64Encode(object);
	
	std::string::iterator iter;
	for(iter = msobj.begin(); iter != msobj.end(); ++iter)
	{
		if (*iter == '=') *iter = '\0';
	}
	unsigned long int sessID=rand()%0xFFFFFF00+4;
	std::string branch = 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		"-" + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		"-" + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		"-" + 
		itoa(rand()%0xAAFF+0x1111, 16) + 
		"-" + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16);
	
	std::string callID = 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		"-" + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		"-" + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		"-" + 
		itoa(rand()%0xAAFF+0x1111, 16) + 
		"-" + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16) + 
		itoa((unsigned long int)rand()%0xAAFF+0x1111, 16);
	
	std::string content = "EUF-GUID: {A4268EEC-FEC5-49E5-95C3-F126696BDBF6}\r\nSessionID: "+ itoa(sessID,10)+"\r\nAppID: 1\r\nContext: "  + msobj;
		
	std::string dataMessage = 
	"INVITE MSNMSGR:"+ buddyid + "  MSNSLP/1.0\r\nTo: <msnmsgr:"	+ buddyid + 
	">\r\nFrom: <msnmsgr:" + userinfo.id + ">\r\nVia: MSNSLP/1.0/TLP ;branch={" + 
	toUpper(branch) + "}\r\nCSeq: 0\r\nCall-ID: {" + toUpper(callID) + 
	"}\r\nMax-Forwards: 0\r\nContent-Type: application/x-msnmsgr-sessionreqbody\r\nContent-Length: "+ 
	itoa(content.length()+5,10) + "\r\n\r\n" + content +	"\r\n\r\n";
	
	send_p2p_message(dataMessage);
}

void 
ChatWindow::send_p2p_message(const std::string& dataMessage)
{
	std::string messageHeader =
	"MIME-Version: 1.0\r\nContent-Type: application/x-msnmsgrp2p\r\nP2P-Dest: "+ buddyid +"\r\n\r\n";

	char binHeader[48];
	
	memset(binHeader, '\0', 48);
	
	if(m_msgIdentifier==0)
		m_msgIdentifier=rand()%0x0FFFFFF0+4;
	else if(m_offset==0)
		m_msgIdentifier++;

	//SessionID
	binHeader[0]=(char)(m_sessionId%256);
	binHeader[1]=(char)((unsigned long int)(m_sessionId/256)%256);
	binHeader[2]=(char)((unsigned long int)(m_sessionId/(256*256))%256);
	binHeader[3]=(char)((unsigned long int)(m_sessionId/(256*256*256))%256);

	//MessageID
	binHeader[4]=(char)(m_msgIdentifier%256);
	binHeader[5]=(char)((unsigned long int)(m_msgIdentifier/256)%256);
	binHeader[6]=(char)((unsigned long int)(m_msgIdentifier/(256*256))%256);
	binHeader[7]=(char)((unsigned long int)(m_msgIdentifier/(256*256*256))%256);

	//offset
	binHeader[8]=(char)(m_offset%256);
	binHeader[9]=(char)((unsigned long int)(m_offset/256)%256);
	binHeader[10]=(char)((unsigned long int)(m_offset/(256*256))%256);
	binHeader[11]=(char)((unsigned long int)(m_offset/(256*256*256))%256);

	unsigned int size=dataMessage.size();

	if(m_totalDataSize) //it's a splitted message
	{
		binHeader[16]=(char)(m_totalDataSize%256);
		binHeader[17]=(char)((unsigned long int)(m_totalDataSize/256)%256);
		binHeader[18]=(char)((unsigned long int)(m_totalDataSize/(256*256))%256);
		binHeader[19]=(char)((unsigned long int)(m_totalDataSize/(256*256*256))%256);

		//update offset
		m_offset+=size;
		if(m_offset>=m_totalDataSize)
		{  //message completely sent, reset values
			m_offset=0;
			m_totalDataSize=0;
		}
	}
	else //not a splitted message, the total size is the current size
	{
		binHeader[16]=(char)size%256;
		binHeader[17]=(int)size/256;
	}

	//message size
	binHeader[24]=(char)size%256;
	binHeader[25]=(int)size/256;

	//Ack sessionID
	/*binHeader[32]=(char)(rand()%256);
	binHeader[33]=(char)(rand()%256);
	binHeader[34]=(char)(rand()%256);
	binHeader[35]=(char)(rand()%256);*/

	binHeader[32]=0xDE;
	binHeader[33]=0xC7;
	binHeader[34]=0x07;
	binHeader[35]=0x14;

/*
	//merge all in a unique message
	char *data;
	unsigned int binsize = strlen(binHeader);
	data = new char(messageHeader.length() + binsize + dataMessage.size() + 4);
	for(unsigned int f=0; f< messageHeader.length() ; f++)
		data[f]=messageHeader[f];
	for(unsigned int f=0; f< binsize; f++)
		data[messageHeader.length()+f]=binHeader[f];
	for(unsigned int f=0; f< dataMessage.size() ; f++)
		data[messageHeader.length()+binsize+f]=dataMessage[f];
	for(unsigned int f=0; f< 4 ; f++) //footer
		data[messageHeader.length()+binsize+dataMessage.size()+f]='\0';

	if(m_sessionId!=0)
	{ //then, the footer ends with \1
		data[messageHeader.length()+binsize + dataMessage.size()  +3 ]='\1';
	}

	//send the message
	sockchannel->sendCommand("MSG  D %d\r\n%s", strlen(data), data);
	*/
}

void
ChatWindow::connect(const std::string ip, const int port, const std::string cki, const int type)
{
	try
	{
		sockchannel = new SockChannel(ip, port);
	}
	catch (SocketException e)
	{
		std::cout << e.description() << std::endl;
		exit(0);
	}
	
	Glib::signal_io().connect(SigC::slot(*this, &ChatWindow::io_handler), sockchannel->getChannel(), Glib::IO_IN | Glib::IO_HUP);
	if (type == RING) {
		sockchannel->sendCommand("ANS  %s %s\r\n", userinfo.id.c_str(), cki.c_str());
	}
	else if (type == CALL) {
		sockchannel->sendCommand("USR  %s %s\r\n", userinfo.id.c_str(), cki.c_str());
	}
}

bool
ChatWindow::io_handler(Glib::IOCondition cond)
{
	static gchar forw[MSN_MAX_BUF_LEN];
	gchar *rest;
	gchar buf[MSN_MAX_BUF_LEN];
	gchar *tok;
			
	std::string data;
	try 
	{
		*sockchannel >> data;
	}
	catch (SocketException e)
	{
		// TODO : 
		//
		// MAKE this window's status to NOT READY to network.
		// and then if User want to make reconnect, have to make it.
		std::cout << e.description() << std::endl;
		return false;
	}

	std::cout 	<< "\n---------------- chatwindow received ----------------\n" 
				<< data 
				<< "\n------------- end of chatwindow received ------------\n" <<std::endl;
	
	if (data.substr(0,3) == "MSG") {
		if(!parse_stream(data)) {
			strcpy(forw,"");
			return false;
		}
	} else {
		strcat(forw, data.c_str());
		
		rest = strrchr(forw,'\n');
		rest++;
		
		if ( *rest != '\0') {
			strcpy(buf, forw);
			buf[rest - forw] = '\0';
			
			tok = strtok(buf, "\r\n");
			if(!parse_stream(tok)) {
				strcpy(forw,"");
				return false;
			}				
			while( (tok = strtok(NULL, "\r\n")) != NULL )
			{
				if(!parse_stream(tok)) {
					strcpy(forw,"");
					return false;
				}
			}
			strcpy(forw, rest);
		}
		else {
			tok = strtok(forw, "\r\n");
			
			if(!parse_stream(tok)) {
				strcpy(forw,"");
				return false;
			}
			while((tok = strtok(NULL, "\r\n")) != NULL )
			{
				if(!parse_stream(tok)) {
					strcpy(forw,"");
					return false;
				}
			}
			strcpy(forw,"");
		}
	}
	
	return true;
}

bool
ChatWindow::parse_stream(const std::string& data)
{
	if(data.substr(0,3) == "USR")
	{
		sockchannel->sendCommand("CAL  %s\r\n", buddyid.c_str());
	}
	else if(data.substr(0,3) == "MSG")
	{
		char nick[500];
		int startpos;
		int endpos;
		
		endpos = data.find("\r\n");
		sscanf( data.substr(0, endpos).c_str(), "%*s %*s %s %*d", nick);
		
		startpos = data.find("Content-Type: ");
		endpos = data.find("\r\n", startpos+15);
		std::string contenttype = data.substr(startpos+14, endpos-startpos-14);
		
		if (contenttype == "text/x-msmsgscontrol") {
			
		} else if (contenttype.substr(0,10) == "text/plain") {
			this->show();
			int pos = data.rfind("X-MMS-IM-Format: ");
			pos = data.find("\r\n\r\n", pos);
			
			std::string str = url_decode(nick);
			str += " say :\r\n     ";
			str += data.substr(pos + 4);
			str += "\r\n";
			Gtk::TextBuffer::iterator iter = textbuffer->end();
			iter = textbuffer->insert(iter, str);
			textmark = textbuffer->create_mark(iter);
			text->scroll_to_mark(textmark, 0.0, 0.0, 1.0);
		}
	}
	else if(data.substr(0,3) == "BYE")
	{
		std::string id = data.substr(4, data.find_first_of(" \r",4) - 4);
		std::list<std::string>::iterator pos;
		pos = find(onsessionbuddylist.begin(), onsessionbuddylist.end(), id);
		onsessionbuddylist.erase(pos);
		
		if (onsessionbuddylist.empty())
		{
			std::string str;
			str = url_decode(id) + " close chatwindow.\r\n";
			Gtk::TextBuffer::iterator iter = textbuffer->end();
			iter = textbuffer->insert(iter, str);
			textmark = textbuffer->create_mark(iter);
			text->scroll_to_mark(textmark, 0.0, 0.0, 1.0);
		
			chatconnection = false;
			return false;
		}
		
		std::string str;
		str = url_decode(id) + " exit from chat.\r\n";
		Gtk::TextBuffer::iterator iter = textbuffer->end();
		iter = textbuffer->insert(iter, str);
		textmark = textbuffer->create_mark(iter);
		text->scroll_to_mark(textmark, 0.0, 0.0, 1.0);
				
		std::cout << "-- on session buddy list --" << std::endl;
		for ( pos = onsessionbuddylist.begin(); pos != onsessionbuddylist.end(); ++pos )
		{
			std::cout << *pos << std::endl;
		}
		std::cout << "-- end of on session buddy list --" << std::endl;
	}
	else if(data.substr(0,3) == "ANS")
	{
		unsigned int find_pos = data.find("OK");
		if(find_pos != std::string::npos)
		{
			chatconnection = true;
			if (buddy[buddyid].msobj == ""){
				// set default picture
				std::cout << "default" << std::endl;
			}
			else {
				std::cout << buddy[buddyid].msobj << std::endl;
				request_display_picture(buddy[buddyid].msobj);
			}
		}
	}
	else if(data.substr(0,3) == "JOI")
	{
		if (!chatconnection) {
			chatconnection = true;
			
			// send all message in queue
			while(!messagequeue.empty()) {
				std::string msg = messagequeue.front();
				sockchannel->sendCommand("MSG  N %d\r\n%s", msg.size(), msg.c_str());
				messagequeue.pop();
			}
			if (buddy[buddyid].msobj == ""){
				// set default picture
				std::cout << "default" << std::endl;
			}
			else {
				std::cout << buddy[buddyid].msobj << std::endl;
				request_display_picture(buddy[buddyid].msobj);
			}
		}
		std::string id = data.substr(4, data.find_first_of(" \r",4) - 4);
		if ( buddy.find(id) != buddy.end() ) {
			int startpos = data.rfind(" ");
			int endpos = data.rfind("\r\n");
			buddy[id].nick = data.substr(startpos + 1, endpos - startpos - 1);
			onsessionbuddylist.push_back(id);
		}
		else {
			int startpos = data.rfind(" ");
			int endpos = data.rfind("\r\n");
			BuddyInfo bi;
			bi.id = id;
			bi.nick = data.substr(startpos + 1, endpos - startpos - 1);
			bi.listnum = 0; // buddy is stranger
			onsessionbuddylist.push_back(id);
		}
		std::cout << "-- on session buddy list --" << std::endl;
		for (std::list<std::string>::iterator pos = onsessionbuddylist.begin(); pos != onsessionbuddylist.end(); ++pos )
		{
			std::cout << *pos << std::endl;
		}
		std::cout << "-- end of on session buddy list --" << std::endl;
		
		std::string str;
		str = url_decode(id) + " joined.\r\n";
		Gtk::TextBuffer::iterator iter = textbuffer->end();
		iter = textbuffer->insert(iter, str);
		textmark = textbuffer->create_mark(iter);
		text->scroll_to_mark(textmark, 0.0, 0.0, 1.0);
		
	}
	else if(data.substr(0,3) == "IRO")
	{
		char id[500];
		sscanf(data.c_str(), "%*s %*d %*d %*d %s %*s", id);
		
		onsessionbuddylist.push_back(id);
	}
	else if(data.substr(0,3) == "217")
	{
		std::string str;
		str = "\r\n*** this connection is closed.\r\n*** Maybe buddy is offline\r\n";
		Gtk::TextBuffer::iterator iter = textbuffer->end();
		iter = textbuffer->insert(iter, str);
		textmark = textbuffer->create_mark(iter);
		text->scroll_to_mark(textmark, 0.0, 0.0, 1.0);

		while(!messagequeue.empty()) 
			messagequeue.pop();
		
		chatconnection = false;
		is_offline = true;
		return false;
	}
	return true;
}
