/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _INVITEWINDOW_H
#define _INVITEWINDOW_H

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif

#include <gtkmm/window.h>
#include "BuddyModel.h"
#include "SockChannel.h"
#include "smartpointer.h"

class InviteWindow : public Gtk::Window
{  
public:
	InviteWindow(const smart_pointer<SockChannel>& _sockchannel,
					std::list<std::string>& _onsessionbuddylist);
	~InviteWindow();

private:
	Gtk::TreeView *treeview;
	Glib::RefPtr<Gtk::TreeSelection> tree;
	smart_pointer<SockChannel> sockchannel;
	std::list<std::string> onsessionbuddylist;

	bool on_window_delete_event(GdkEventAny *event);
	void on_ok_clicked();
	void on_cancel_clicked();
	void on_row_activated(const Gtk::TreeModel::Path& path, Gtk::TreeViewColumn* column);
};
#endif /* _INVITEWINDOW_H */
