/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gdk/gdkkeysyms.h>
#include <gtkmm/imagemenuitem.h>
#include <gtk/gtkimagemenuitem.h>
#include <gtkmm/menuitem.h>
#include <gtkmm/menu.h>
#include <gtkmm/menubar.h>
#include <gtkmm/textview.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/treeview.h>
#include <gtkmm/box.h>
#include <gdkmm/pixbuf.h>
#include <gtkmm/image.h>
#include <gtkmm/cellrendererpixbuf.h>
#include "MainWindow.h"
#include "global.h"
#include "md5.h"
#include "Utility.h"

Glib::RefPtr<Gdk::Pixbuf> buddyimage[8];
Glib::RefPtr<Gdk::Pixbuf> statusimage[8];

MainWindow::MainWindow()
{
	statusimage[FLN] = Gdk::Pixbuf::create_from_file(pixmap_dir("msn34gray.png"));
	statusimage[NLN] = Gdk::Pixbuf::create_from_file(pixmap_dir("msn34.png"));
	statusimage[IDL] = Gdk::Pixbuf::create_from_file(pixmap_dir("msn34idle.png"));
	statusimage[BSY] = Gdk::Pixbuf::create_from_file(pixmap_dir("msn34busy.png"));
	statusimage[AWY] = statusimage[IDL];
	statusimage[PHN] = statusimage[BSY];
	statusimage[LUN] = statusimage[IDL];
	statusimage[BRB] = statusimage[IDL];
	
	buddyimage[FLN] = Gdk::Pixbuf::create_from_file(pixmap_dir("msn24gray.png"));
	buddyimage[NLN] = Gdk::Pixbuf::create_from_file(pixmap_dir("msn24.png"));
	buddyimage[IDL] = Gdk::Pixbuf::create_from_file(pixmap_dir("msn24idle.png"));
	buddyimage[BSY] = Gdk::Pixbuf::create_from_file(pixmap_dir("msn24busy.png"));
	buddyimage[AWY] = buddyimage[IDL];
	buddyimage[PHN] = buddyimage[BSY];
	buddyimage[LUN] = buddyimage[IDL];
	buddyimage[BRB] = buddyimage[IDL];
	
	Gtk::ImageMenuItem *_________________n_1 = NULL;
	Gtk::ImageMenuItem *_______o_1 = NULL;
	Gtk::ImageMenuItem *_______s_1 = NULL;
	Gtk::ImageMenuItem *___________________________a_1 = NULL;
	Gtk::MenuItem *separatormenuitem1 = NULL;
	Gtk::ImageMenuItem *__________q_1 = NULL;
	Gtk::Menu *menu1 = Gtk::manage(new class Gtk::Menu());
	Gtk::MenuItem *menuitem1 = NULL;
	Gtk::ImageMenuItem *_____________t_1 = NULL;
	Gtk::ImageMenuItem *_______c_1 = NULL;
	Gtk::ImageMenuItem *______________p_1 = NULL;
	Gtk::ImageMenuItem *__________d_1 = NULL;
	Gtk::Menu *menu2 = Gtk::manage(new class Gtk::Menu());
	Gtk::MenuItem *menuitem2 = NULL;
	Gtk::Menu *menu3 = Gtk::manage(new class Gtk::Menu());
	Gtk::MenuItem *menuitem3 = NULL;
	Gtk::MenuItem *about1 = NULL;
	Gtk::Menu *menu4 = Gtk::manage(new class Gtk::Menu());
	Gtk::MenuItem *menuitem4 = NULL;
	Gtk::MenuBar *menubar1 = Gtk::manage(new class Gtk::MenuBar());
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-new")));
	_________________n_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-open")));
	_______o_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-save")));
	_______s_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-save-as")));
	___________________________a_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::SeparatorElem());
	separatormenuitem1 = (Gtk::MenuItem *)&menu1->items().back();
	
	menu1->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-quit")));
	__________q_1 = (Gtk::ImageMenuItem *)&menu1->items().back();
	
	menu2->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-cut")));
	_____________t_1 = (Gtk::ImageMenuItem *)&menu2->items().back();
	
	menu2->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-copy")));
	_______c_1 = (Gtk::ImageMenuItem *)&menu2->items().back();
	
	menu2->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-paste")));
	______________p_1 = (Gtk::ImageMenuItem *)&menu2->items().back();
	
	menu2->items().push_back(Gtk::Menu_Helpers::StockMenuElem(Gtk::StockID("gtk-delete")));
	__________d_1 = (Gtk::ImageMenuItem *)&menu2->items().back();
	
	menu4->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_About")));
	about1 = (Gtk::MenuItem *)&menu4->items().back();
	
	menubar1->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_File"), *menu1));
	menuitem1 = (Gtk::MenuItem *)&menubar1->items().back();
	
	menubar1->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_Edit"), *menu2));
	menuitem2 = (Gtk::MenuItem *)&menubar1->items().back();
	
	menubar1->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_View"), *menu3));
	menuitem3 = (Gtk::MenuItem *)&menubar1->items().back();
	
	menubar1->items().push_back(Gtk::Menu_Helpers::MenuElem(_("_Help"), *menu4));
	menuitem4 = (Gtk::MenuItem *)&menubar1->items().back();

	menu1->set_name("menu1");
	menu2->set_name("menu2");
	menu3->set_name("menu3");
	menu4->set_name("menu4");
	menubar1->set_name("menubar1");
	_________________n_1->show();
	_______o_1->show();
	_______s_1->show();
	___________________________a_1->show();
	separatormenuitem1->show();
	__________q_1->show();
	menuitem1->show();
	_____________t_1->show();
	_______c_1->show();
	______________p_1->show();
	__________d_1->show();
	menuitem2->show();
	menuitem3->show();
	about1->show();
	menuitem4->show();
	menubar1->show();

	statimage = Gtk::manage(new class Gtk::Image());
	statimage->set_alignment(0.0,0.5);
	statimage->set_padding(0,0);
	
   	statlabel = Gtk::manage(new class Gtk::Label());
	statlabel->set_alignment(0.0,0.5);
	statlabel->set_padding(0,0);
	statlabel->set_justify(Gtk::JUSTIFY_LEFT);
	statlabel->set_line_wrap(true);
	statlabel->set_use_markup(true);
	statlabel->set_selectable(false);
	
	Gtk::HBox *hbox1 = Gtk::manage(new class Gtk::HBox(false, 0));
	hbox1->pack_start(*statimage, Gtk::PACK_SHRINK, 0);
	hbox1->pack_start(*statlabel);
	
	hbox1->show();
	
	Gtk::TreeViewColumn *const column = new Gtk::TreeViewColumn();	
	CellRendererIcon *const iconrenderer = new CellRendererIcon();
	column->pack_start(*iconrenderer, false);
	column->add_attribute(iconrenderer->property_pixbuf(), buddycolumnmodel.icon);
	column->add_attribute(iconrenderer->property_visible(), buddycolumnmodel.icon_visible);
	CellRendererNick *const nickrenderer = new CellRendererNick();
	column->pack_start(*nickrenderer, true);
	column->add_attribute(nickrenderer->property_markup(), buddycolumnmodel.nick);

	treeview = Gtk::manage(new class Gtk::TreeView());
	treemodel = Gtk::TreeStore::create(buddycolumnmodel);
	treeview->set_model(treemodel);
	treeview->set_name("treeview");
	treeview->set_flags(Gtk::CAN_FOCUS);
	treeview->set_headers_visible(false);
	treeview->set_rules_hint(false);
	treeview->set_reorderable(false);
	treeview->set_enable_search(false);
	treeview->signal_row_activated().connect(SigC::slot(*this, &MainWindow::on_row_activated));
	treeview->append_column(*Gtk::manage(column));
	treeview->show();
	
	Gtk::ScrolledWindow *scrolledwindow2 = Gtk::manage(new class Gtk::ScrolledWindow());
	scrolledwindow2->set_name("scrolledwindow2");
	scrolledwindow2->set_shadow_type(Gtk::SHADOW_NONE);
	scrolledwindow2->set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);
	scrolledwindow2->property_window_placement().set_value(Gtk::CORNER_TOP_LEFT);
	scrolledwindow2->add(*treeview);
	scrolledwindow2->show();

	Gtk::VBox *vbox1 = Gtk::manage(new class Gtk::VBox(false, 0));
	vbox1->set_name("vbox1");
	vbox1->pack_start(*menubar1, Gtk::PACK_SHRINK, 0);
	vbox1->pack_start(*hbox1, Gtk::PACK_SHRINK, 0);
	vbox1->pack_start(*scrolledwindow2);
	vbox1->show();

	this->set_name("MainWindow");
	this->set_title(_("FMSN"));
	this->set_modal(false);
	this->property_window_position().set_value(Gtk::WIN_POS_NONE);
	this->set_resizable(true);
	this->set_default_size(280, 350);
	this->property_destroy_with_parent().set_value(false);
	this->add(*vbox1);
	
	/*
	_________________n_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on__________________n_1_activate));
	_______o_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on________o_1_activate));
	_______s_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on________s_1_activate));
	___________________________a_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on____________________________a_1_activate));
	__________q_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on___________q_1_activate));
	_____________t_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on______________t_1_activate));
	_______c_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on________c_1_activate));
	______________p_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on_______________p_1_activate));
	__________d_1->signal_activate().connect(SigC::slot(*this, &MainWindow::on___________d_1_activate));
	about1->signal_activate().connect(SigC::slot(*this, &MainWindow::on_about1_activate));
	*/
}

MainWindow::~MainWindow()
{
	std::cout << "mainwindow deleted" << std::endl;
}


bool 
MainWindow::on_chatwindow_delete_event(GdkEventAny *event, const std::string id)
{
	std::cout << "\nchatwindow end: " << id << std::endl;
	
	chatwindowmap.erase(id);
	return true;
}

void 
MainWindow::on_row_activated(const Gtk::TreeModel::Path& path, Gtk::TreeViewColumn* column)
{
	const Gtk::TreeModel::iterator iter = treemodel->get_iter(path);
	if (iter)
	{
		std::string id;
		Gtk::TreeModel::Row row = *iter;
		id = row[buddycolumnmodel.id];
		if (row[buddycolumnmodel.icon_visible] == false)  //is group
		{
			if ( treeview->row_expanded(path) ) {
				treeview->collapse_row(path);
			} else {
				treeview->expand_row(path, true);
			}
		}
		else if (buddy[id].status != FLN) 
		{
			if (chatwindowmap.find(id) == chatwindowmap.end())
			{
				std::cout << "select : " << id << std::endl;
				registchatwaitlist(id);
			}
			else 
			{
				chatwindowmap[id]->show();
			}
		} 
	}
}

void 
MainWindow::registchatwaitlist(const std::string id)
{
	chatwaitlist.push_back(id);
	sockchannel->sendCommand("XFR  SB\r\n");
}

void 
MainWindow::connect(const std::string ip, const int port)
{
	try
	{
		sockchannel = new SockChannel(ip, port);
	}
	catch (SocketException e)
	{
		std::cout << e.description() << std::endl;
		exit(0);
	}
	
	Glib::signal_io().connect(SigC::slot(*this, &MainWindow::io_handler), sockchannel->getChannel(), Glib::IO_IN | Glib::IO_HUP);
	sockchannel->sendCommand("VER  MSNP9 MSNP8 CVR0\r\n");
}

bool
MainWindow::io_handler(Glib::IOCondition cond)
{
	static gchar forw[MSN_MAX_BUF_LEN];
	gchar *rest;
	gchar buf[MSN_MAX_BUF_LEN];
	gchar *tok;
			
	std::string data;
	try 
	{
		*sockchannel >> data;
	}
	catch (SocketException e)
	{
		// TODO : 
		//
		// MAKE this window's status to NOT READY to network.
		// and then if User want to make reconnect, have to make it.
		std::cout << e.description() << std::endl;
		return false;
	}

	std::cout 	<< "\n---------------- mainwindow received ----------------\n" 
				<< data 
				<< "\n------------- end of mainwindow received ------------\n" <<std::endl;
	
	if (data.substr(0,3) == "MSG") {
		if(!parse_stream(data)) {
			strcpy(forw,"");
			return false;
		}
	} else {
		strcat(forw, data.c_str());
		
		rest = strrchr(forw,'\n');
		rest++;
		
		if ( *rest != '\0') {
			strcpy(buf, forw);
			buf[rest - forw] = '\0';
			
			tok = strtok(buf, "\r\n");
			if(!parse_stream(tok)) {
				strcpy(forw,"");
				return false;
			}				
			while( (tok = strtok(NULL, "\r\n")) != NULL )
			{
				if(!parse_stream(tok)) {
					strcpy(forw,"");
					return false;
				}
			}
			strcpy(forw, rest);
		}
		else {
			tok = strtok(forw, "\r\n");
			
			if(!parse_stream(tok)) {
				strcpy(forw,"");
				return false;
			}
			while((tok = strtok(NULL, "\r\n")) != NULL )
			{
				if(!parse_stream(tok)) {
					strcpy(forw,"");
					return false;
				}
			}
			strcpy(forw,"");
		}
	}
	
	return true;
}


bool
MainWindow::find_iter_from_id(const std::string& id, Gtk::TreeIter& iter)
{
	Gtk::TreeNodeChildren child = group[buddy[id].groupnum].iter->children();
	for(iter = child.begin(); iter != child.end(); ++iter)
	{
		std::string str = (*iter)[buddycolumnmodel.id];
		if ( id == str )
		{
			return true;
		}
	}
	return false;
}

bool
MainWindow::parse_stream(const std::string& data)
{
	if(data.substr(0,3) == "RNG")
	{
		gchar id[500], session_id[10], ip[16], cki[50], nick[500];
		gint port;
		
		sscanf(data.c_str(), "%*s %s %[^:]:%d %*s %s %s %s", session_id, ip, &port, cki, id, &nick);
		
		buddy[id].nick = nick;
		
		strcat(cki, " ");
		strcat(cki, session_id);
		if (chatwindowmap.find(id) == chatwindowmap.end())
		{
			chatwindowmap[id] = new ChatWindow(id);
			chatwindowmap[id]->connect(ip, port, cki, RING);
		}
		else
		{
			chatwindowmap[id]->connect(ip, port, cki, RING);
		}
	}
	else if(data.substr(0,3) == "XFR")
	{
		char ip[16];
		int port;
		char cki[50];
		sscanf(data.c_str(), "%*s %*d %*s %[^:]:%d %*s %s", ip, &port, cki);
		
		std::string id = chatwaitlist.front();
		std::cout << "make chatwindow to " << id << std::endl;
		
		if (chatwindowmap.find(id) == chatwindowmap.end())
		{
			chatwindowmap[id] = new ChatWindow(id);
			chatwindowmap[id]->connect(ip, port, cki, CALL);
			chatwindowmap[id]->show();
		}
		else
		{
			chatwindowmap[id]->connect(ip, port, cki, CALL);
		}
		chatwaitlist.pop_front();
	}
	else if (data.substr(0,3) == "FLN")
	{
		//TODO :
		//
		// if ONline OFFline move online to offline
		// and if OFFline invisible, then remove from buddy list
		
		unsigned int startpos = data.find(" ");
		unsigned int endpos = data.find("\r\n",startpos+1);
		std::string id = data.substr(startpos+1, endpos-startpos-1);
		buddy[id].status = FLN;
		
		Gtk::TreeIter iter;
		if (find_iter_from_id(id, iter))
		{
			/*
			std::string mark = "<span foreground='dim grey'>";
			mark += (*iter)[buddycolumnmodel.nick];
			mark += "</span>";
			(*iter)[buddycolumnmodel.nick] = mark;
			(*iter)[buddycolumnmodel.icon] = buddyimage[FLN];
			*/
			treemodel->erase(iter);
		}
	}
	else if (data.substr(0,3) == "ILN")
	{
		char status[4];
		char id[500], nick[1000];
		char msobj[1000] = "";
		int clientid;
		
		sscanf(data.c_str(), "%*s %*d %s %s %s %d %s", status, id, nick, &clientid, msobj);
		
		buddy[id].msobj = url_decode_unescape(msobj);
		
		Gtk::TreeModel::Row row = *(treemodel->append(group[buddy[id].groupnum].iter->children()));
		row[buddycolumnmodel.id] = id;			
		row[buddycolumnmodel.groupnum] = buddy[id].groupnum;
		row[buddycolumnmodel.icon_visible] = true;
		
		if (!strncmp(status,"NLN",3))
		{
			buddy[id].status = NLN;
			row[buddycolumnmodel.nick] = url_decode(nick);
			row[buddycolumnmodel.icon] = buddyimage[NLN];
			row[buddycolumnmodel.status] = NLN;
		}
		if (!strncmp(status,"BSY",3))
		{
			buddy[id].status = BSY;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>busy</span>";
			row[buddycolumnmodel.icon] = buddyimage[BSY];
			row[buddycolumnmodel.status] = BSY;
		}
		if (!strncmp(status,"IDL",3))
		{
			buddy[id].status = IDL;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>idle</span>";
			row[buddycolumnmodel.icon] = buddyimage[IDL];
			row[buddycolumnmodel.status] = IDL;
		}
		if (!strncmp(status,"BRB",3))
		{
			buddy[id].status = BRB;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>be right back</span>";
			row[buddycolumnmodel.icon] = buddyimage[BRB];
			row[buddycolumnmodel.status] = BRB;
		}
		if (!strncmp(status,"AWY",3))
		{
			buddy[id].status = AWY;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>away</span>";
			row[buddycolumnmodel.icon] = buddyimage[AWY];
			row[buddycolumnmodel.status] = AWY;
		}
		if (!strncmp(status,"PHN",3))
		{
			buddy[id].status = PHN;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>on the phone</span>";
			row[buddycolumnmodel.icon] = buddyimage[PHN];
			row[buddycolumnmodel.status] = PHN;
		}
		if (!strncmp(status,"LUN",3))
		{
			buddy[id].status = LUN;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>lunch</span>";
			row[buddycolumnmodel.icon] = buddyimage[LUN];
			row[buddycolumnmodel.status] = LUN;
		}
		
		//fix it later
		treeview->expand_all();
	}
	else if (data.substr(0,3) == "NLN")
	{
		char status[4];
		char id[500], nick[1000];
		int clientid;
		char msobj[1000] = "";
		sscanf(data.c_str(), "%*s %s %s %s %d", status, id, nick, &clientid, msobj);
		
		buddy[id].msobj = url_decode_unescape(msobj);
				
		Gtk::TreeIter iter;
		Gtk::TreeModel::Row row;
		if (!find_iter_from_id(id, iter)) {
			row = *(treemodel->append(group[buddy[id].groupnum].iter->children()));
			row[buddycolumnmodel.id] = id;
			row[buddycolumnmodel.groupnum] = buddy[id].groupnum;
			row[buddycolumnmodel.icon_visible] = true;
		}
		else {
			row = (*iter);
		}
		
		if (!strncmp(status,"NLN",3))
		{
			buddy[id].status = NLN;
			row[buddycolumnmodel.nick] = url_decode(nick);
			row[buddycolumnmodel.icon] = buddyimage[NLN];
			row[buddycolumnmodel.status] = NLN;
		}
		if (!strncmp(status,"BSY",3))
		{
			buddy[id].status = BSY;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>busy</span>";
			row[buddycolumnmodel.icon] = buddyimage[BSY];
			row[buddycolumnmodel.status] = BSY;
		}
		if (!strncmp(status,"IDL",3))
		{
			buddy[id].status = IDL;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>idle</span>";
			row[buddycolumnmodel.icon] = buddyimage[IDL];
			row[buddycolumnmodel.status] = IDL;
		}
		if (!strncmp(status,"BRB",3))
		{
			buddy[id].status = BRB;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>be right back</span>";
			row[buddycolumnmodel.icon] = buddyimage[BRB];
			row[buddycolumnmodel.status] = BRB;
		}
		if (!strncmp(status,"AWY",3))
		{
			buddy[id].status = AWY;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>away</span>";
			row[buddycolumnmodel.icon] = buddyimage[AWY];
			row[buddycolumnmodel.status] = AWY;
		}
		if (!strncmp(status,"PHN",3))
		{
			buddy[id].status = PHN;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>on the phone</span>";
			row[buddycolumnmodel.icon] = buddyimage[PHN];
			row[buddycolumnmodel.status] = PHN;
		}
		if (!strncmp(status,"LUN",3))
		{
			buddy[id].status = LUN;
			row[buddycolumnmodel.nick] = url_decode(nick) + "\n<span size='smaller' foreground='dim grey'>lunch</span>";
			row[buddycolumnmodel.icon] = buddyimage[LUN];
			row[buddycolumnmodel.status] = LUN;
		}
		
		//fix it later
		treeview->expand_all();
	}
	else if (data.substr(0,3) == "LSG")
	{
		char groupname[500];
		int groupnum;
		
		//TODO:
		//
		// correct parsing 
		
		sscanf(data.c_str(), "%*s %d %s %*d", &groupnum, groupname);

		Gtk::TreeIter iter = treemodel->append();
		
		group[groupnum].groupname = groupname;
		group[groupnum].iter = iter;
		// TODO:
		//
		// if GROUP or ONline OFFline
		std::string mark;
		mark = "<span weight='bold'>";
		mark += url_decode(groupname);
		mark += "</span>";
		
		(*iter)[buddycolumnmodel.groupnum] = groupnum;
		(*iter)[buddycolumnmodel.icon_visible] = false;
		(*iter)[buddycolumnmodel.nick] = mark;
	} 
	else if (data.substr(0,3) == "LST")
	{
		int groupnum = 0;
		int listnum;
		char id[500], nick[500];
		//fix it group can be not available
		sscanf(data.c_str(), "%*s %s %s %d %d", id, nick, &listnum, &groupnum);
		
		buddy[id].id = id;
		buddy[id].groupnum = groupnum;
		buddy[id].listnum = listnum;
		buddy[id].nick = nick;
		buddy[id].status = FLN;
		
		// TODO:
		//		
		//if GROUP or ONline OFFline
		/*
		std::string mark = "<span foreground='dim grey'>";
		mark += url_decode(nick);
		mark += "</span>";
		
		(*iter)[buddycolumnmodel.id] = id;			
		(*iter)[buddycolumnmodel.groupnum] = groupnum;
		(*iter)[buddycolumnmodel.icon_visible] = true;
		(*iter)[buddycolumnmodel.nick] = mark;
		(*iter)[buddycolumnmodel.icon] = buddyimage[FLN];
		*/
	}
	else if (data.substr(0,3) == "VER")
	{
		sockchannel->sendCommand("CVR  0x0409 winnt 5.1 i386 MSNMSGR 6.0.0602 MSMSGS %s\r\n",userinfo.id.c_str());
	}
	else if (data.substr(0,3) == "CVR")
	{
		sockchannel->sendCommand("USR  TWN I %s\r\n",userinfo.id.c_str());
	}
	else if (data.substr(0,3) == "USR")
	{
		unsigned int startpos = data.find("TWN");
		unsigned int endpos;
		if (startpos >= 0 && startpos < data.size())
		{
			startpos = data.find(" ",startpos + 4);
			ssl_process(data.substr(startpos+1));
		}
		startpos = data.find("OK");
		if (startpos >= 0 && startpos < data.size()) 
		{
			startpos = data.find(" ",startpos + 3);
			endpos = data.find(" ", startpos + 1);
			userinfo.nick = data.substr(startpos + 1, endpos-startpos-1);
			std::string mark = "<span size='smaller' foreground='dim grey'>My status is ...</span>\n<span weight='bold' size='larger'>";
			mark += url_decode(userinfo.nick);
			mark += "</span>";
			statlabel->set_markup(mark);
			statimage->set(statusimage[NLN]);
			statimage->show();
			statlabel->show();
			sockchannel->sendCommand("SYN  0\r\n");
			sockchannel->sendCommand("CHG  NLN 0\r\n");
		}
			
	}
	else if (data.substr(0,3) == "CHL")
	{
		md5_state_t state; 
		md5_byte_t digest[16];
		char hash[200];
		char temp[200];
		int i;
				
		sscanf(data.c_str(), "%*s %*d %s", hash);

		md5_init(&state);
		md5_append(&state, (const md5_byte_t *)hash, strlen(hash));
		md5_append(&state, (const md5_byte_t *)"VT6PX?UQTM4WM%YR", strlen("VT6PX?UQTM4WM%YR"));
		md5_finish(&state, digest);

		for (i = 0; i < 16; ++i) {
				if(i == 0)
						sprintf(temp, "%02x", digest[i]);
				else
						sprintf(temp, "%s%02x", temp, digest[i]);
		}
        sockchannel->sendCommand("QRY  PROD0038W!61ZTF9 32\r\n%s",temp);
	}
	
	return true;	
}
	
void 
MainWindow::ssl_process(const std::string parameters)
{
	std::string data;
	
	char *base, *da_login;
	char *request_str;
	
	char *challenge_data;
	char *key, *value = NULL;
	char *c;
	
	if (userinfo.ssl_challenge_data != NULL) g_hash_table_destroy(userinfo.ssl_challenge_data);
	userinfo.ssl_challenge_data = g_hash_table_new_full(g_str_hash, g_str_equal,
								  g_free, g_free);
	challenge_data = g_strdup(parameters.c_str());
	for (c = challenge_data, key = challenge_data; *c != '\0'; c++)
	{
		if (*c == '=')
		{
			*c = '\0';
			value = c + 1;
		}
		else if (*c == ',')
		{
			*c = '\0';
			g_hash_table_insert(userinfo.ssl_challenge_data, g_strdup(key), g_strdup(value));
			key = c + 1;
		}
	}
	g_hash_table_insert(userinfo.ssl_challenge_data, g_strdup(key), g_strdup(value));
	g_free(challenge_data);
	
	try 
	{
		nexuschannel = new SSLSockChannel(MSN_PASSPORT_SERVER_ADDRESS, MSN_PASSPORT_SERVER_PORT);
	}
	catch (SocketException e)
	{
		std::cout << e.description() << std::endl;
		exit(0);
	}
	*nexuschannel << "GET /rdr/pprdr.asp HTTP/1.0\r\n\r\n";
	try 
	{
		*nexuschannel >> data;
	}
	catch (SocketException e)
	{
		std::cout << e.description() << std::endl;
		exit(0);
	}
	
	std::cout << data << std::endl;
	
	base = strstr(data.c_str(), "PassportURLs");
	if ((da_login = strstr(base, "DALogin=")) != NULL)
	{
		if ((da_login = strchr(da_login, '=')) != NULL)
			da_login++;
		
		if ((c = strchr(da_login, ',')) != NULL)
			*c = '\0';
		
		if ((c = strchr(da_login, '/')) != NULL)
		{
			userinfo.ssl_login_path = c;
			
			*c = '\0';
		}
		userinfo.ssl_login_host = da_login;
	}
	
	for(;;) 
	{
		request_str = g_strdup_printf(
			"GET %s HTTP/1.1\r\n"
			"Authorization: Passport1.4 OrgVerb=GET,OrgURL=%s,sign-in=%s,pwd=%s,"
			"lc=%s,id=%s,tw=%s,fs=%s,ru=%s,ct=%s,kpp=%s,kv=%s,ver=%s,tpf=%s\r\n"
			"User-Agent: MSMSGS\r\n"
			"Host: %s\r\n"
			"Connection: Keep-Alive\r\n"
			"Cache-Control: no-cache\r\n"
			"\r\n",
			userinfo.ssl_login_path.c_str(),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "ru"),
			url_encode(userinfo.id).c_str(), url_encode(userinfo.password).c_str(),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "lc"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "id"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "tw"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "fs"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "ru"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "ct"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "kpp"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "kv"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "ver"),
			(char *)g_hash_table_lookup(userinfo.ssl_challenge_data, "tpf"),
			userinfo.ssl_login_host.c_str());
		try 
		{
			nexuschannel = new SSLSockChannel(userinfo.ssl_login_host, MSN_PASSPORT_SERVER_PORT);
		}
		catch (SocketException e)
		{
			std::cout << e.description() << std::endl;
			exit(0);
		}
		*nexuschannel << request_str;
		try 
		{
			*nexuschannel >> data;
		}
		catch (SocketException e)
		{
			std::cout << e.description() << std::endl;
			exit(0);
		}
		std::cout << data << std::endl;
		
		if (strstr(data.c_str(), "HTTP/1.1 200") != NULL) {
			g_free (request_str);
			break;
		} else if (strstr(data.c_str(), "HTTP/1.1 401") != NULL) {
			g_free (request_str);
			break;
			//error
		} else {
			char *location, *c;
			if ((location = strstr(data.c_str(), "Location: "))==NULL)
			{
				//err
			}
			location = strchr(location, ' ') + 1;
	
			if ((c = strchr(location, '\r')) != NULL)
				*c = '\0';
	
			/* Skip the http:// */
			if ((c = strchr(location, '/')) != NULL)
				location = c + 2;
	
			if ((c = strchr(location, '/')) != NULL)
			{
				userinfo.ssl_login_path = c;
	
				*c = '\0';
			}
	
			userinfo.ssl_login_host = location;
			g_free (request_str);
		}
	}
	int startpos, endpos;
	startpos = data.find("from-PP='");
	endpos = data.find("'",startpos+11);
	std::cout << startpos <<":" <<  endpos << std::endl; 
	data = data.substr(startpos+9,endpos-startpos-9);
	std::cout << "send :" << data << std::endl; 
	sockchannel->sendCommand("USR  TWN S %s\r\n",data.c_str()); 
	return;
}
