/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _MAIN_WINDOW_H
#define _MAIN_WINDOW_H

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif

#include "ChatWindow.h"
#include "BuddyModel.h"
#include "SockChannel.h"
#include "SSLSockChannel.h"

#include <gtkmm/window.h>
#include <glibmm/ustring.h>
#include <map>
#include <queue>
#include "smartpointer.h"
typedef smart_pointer<ChatWindow> ChatWindowPtr;
typedef smart_pointer<SockChannel> SockChannelPtr;
typedef smart_pointer<SSLSockChannel> SSLSockChannelPtr;

class MainWindow : public Gtk::Window
{ 
public:
	MainWindow();
	~MainWindow();
	void connect(const std::string ip, const int port);
	bool on_chatwindow_delete_event(GdkEventAny *event, const std::string id);
	void registchatwaitlist(const std::string id);
	BuddyColumnModel buddycolumnmodel;
	Glib::RefPtr<Gtk::TreeStore> treemodel;
	
private:
	std::map<const std::string, ChatWindowPtr > chatwindowmap;
	Gtk::Image* statimage;
	Gtk::Label* statlabel;
	Gtk::TreeView *treeview;
	
	std::deque<std::string> chatwaitlist;
	
	SockChannelPtr sockchannel;
	SSLSockChannelPtr nexuschannel;
	
	bool find_iter_from_id(const std::string& id, Gtk::TreeIter& iter);
	void ssl_process(const std::string parameters);
	bool io_handler(Glib::IOCondition cond);
	bool parse_stream(const std::string& data);
	void on_row_activated(const Gtk::TreeModel::Path& path, Gtk::TreeViewColumn* column);
};

#endif /* _MAIN_WINDOW_H */
