/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "OptionWindow.h"

#include <gdk/gdkkeysyms.h>
#include <gtkmm/textview.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/box.h>
#include <gtkmm/separator.h>
#include <gtkmm/image.h>
#include <gtkmm/label.h>
#include <gtkmm/alignment.h>
#include <gtkmm/button.h>
#include <gtkmm/buttonbox.h>
#include "global.h"
OptionWindow::OptionWindow()
{  
	Gtk::TextView *textview5 = Gtk::manage(new class Gtk::TextView());
	Gtk::ScrolledWindow *scrolledwindow6 = Gtk::manage(new class Gtk::ScrolledWindow());
	Gtk::HBox *hbox4 = Gtk::manage(new class Gtk::HBox(false, 0));
	Gtk::HSeparator *hseparator1 = Gtk::manage(new class Gtk::HSeparator());
	Gtk::Image *image7 = Gtk::manage(new class Gtk::Image(Gtk::StockID("gtk-ok"), Gtk::IconSize(4)));
	Gtk::Label *label6 = Gtk::manage(new class Gtk::Label(_("button6")));
	Gtk::HBox *hbox5 = Gtk::manage(new class Gtk::HBox(false, 2));
	Gtk::Alignment *alignment4 = Gtk::manage(new class Gtk::Alignment(0.5, 0.5, 0, 0));
	Gtk::Button *button6 = Gtk::manage(new class Gtk::Button());
	Gtk::HButtonBox *hbuttonbox3 = Gtk::manage(new class Gtk::HButtonBox(Gtk::BUTTONBOX_END, 0));
	Gtk::VBox *vbox4 = Gtk::manage(new class Gtk::VBox(false, 0));
	textview5->set_name("textview5");
	textview5->set_flags(Gtk::CAN_FOCUS);
	textview5->set_editable(false);
	textview5->set_cursor_visible(false);
	textview5->set_pixels_above_lines(0);
	textview5->set_pixels_below_lines(0);
	textview5->set_pixels_inside_wrap(0);
	textview5->set_left_margin(0);
	textview5->set_right_margin(0);
	textview5->set_indent(0);
	textview5->set_wrap_mode(Gtk::WRAP_NONE);
	textview5->set_justification(Gtk::JUSTIFY_LEFT);
	scrolledwindow6->set_name("scrolledwindow6");
	scrolledwindow6->set_flags(Gtk::CAN_FOCUS);
	scrolledwindow6->set_shadow_type(Gtk::SHADOW_NONE);
	scrolledwindow6->set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_NEVER);
	scrolledwindow6->property_window_placement().set_value(Gtk::CORNER_TOP_LEFT);
	scrolledwindow6->add(*textview5);
	hbox4->set_name("hbox4");
	hbox4->pack_start(*scrolledwindow6);
	hseparator1->set_name("hseparator1");
	image7->set_name("image7");
	image7->set_alignment(0.5,0.5);
	image7->set_padding(0,0);
	label6->set_name("label6");
	label6->set_alignment(0.5,0.5);
	label6->set_padding(0,0);
	label6->set_justify(Gtk::JUSTIFY_LEFT);
	label6->set_line_wrap(false);
	label6->set_use_markup(false);
	label6->set_selectable(false);
	hbox5->set_name("hbox5");
	hbox5->pack_start(*image7, Gtk::PACK_SHRINK, 0);
	hbox5->pack_start(*label6, Gtk::PACK_SHRINK, 0);
	alignment4->set_name("alignment4");
	alignment4->add(*hbox5);
	button6->set_name("button6");
	button6->set_flags(Gtk::CAN_FOCUS);
	button6->set_relief(Gtk::RELIEF_NORMAL);
	button6->add(*alignment4);
	hbuttonbox3->set_name("hbuttonbox3");
	hbuttonbox3->pack_start(*button6);
	vbox4->set_name("vbox4");
	vbox4->pack_start(*hbox4);
	vbox4->pack_start(*hseparator1, Gtk::PACK_SHRINK, 4);
	vbox4->pack_start(*hbuttonbox3, Gtk::PACK_SHRINK, 0);
	this->set_name("OptionWindow");
	this->set_title(_("Option"));
	this->set_modal(false);
	this->property_window_position().set_value(Gtk::WIN_POS_NONE);
	this->set_resizable(true);
	this->property_destroy_with_parent().set_value(false);
	this->add(*vbox4);
	textview5->show();
	scrolledwindow6->show();
	hbox4->show();
	hseparator1->show();
	image7->show();
	label6->show();
	hbox5->show();
	alignment4->show();
	button6->show();
	hbuttonbox3->show();
	vbox4->show();
	
	button6->signal_clicked().connect(SigC::slot(*this, &OptionWindow::on_close_clicked));	
	this->signal_delete_event().connect(SigC::slot(*mainwindow, &OptionWindow::on_delete_event));
}

OptionWindow::~OptionWindow()
{
	std::cout << "Optionwindow deleted" << std::endl;
}

bool 
OptionWindow::on_chatwindow_delete_event(GdkEventAny *event)
{
	hide();
	return true;
}

void 
OptionWindow::on_close_clicked()
{
	hide();
}
