/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef _SSLSOCKCHANNEL_H
#define _SSLSOCKCHANNEL_H

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif
#include "SockChannel.h"
#include "SocketException.h"
#include <iostream>
#include <glibmm/iochannel.h>
#include <glibmm/ustring.h>
#include <gnutls/gnutls.h>

#define CAFILE "ca.pem"
#define SSL_MAX_BUF 5000

class SSLSockChannel : public SockChannel
{
public:
	SSLSockChannel ( std::string host, int port );
	~SSLSockChannel();
	const SSLSockChannel& operator << ( const std::string& ) const;
	const SSLSockChannel& operator >> ( std::string& ) const;
private:
	gnutls_session session;
	gnutls_certificate_credentials xcred;
};
#endif /* _SSLSOCKCHANNEL_H */
