/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef _SOCKCHANNEL_H
#define _SOCKCHANNEL_H

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif

#include "Socket.h"
#include "SocketException.h"
#include <iostream>
#include <glibmm/iochannel.h>
#include <glibmm/ustring.h>

class SockChannel : public Socket
{
public:
	SockChannel ( std::string host, int port );
	~SockChannel();
	
	const virtual SockChannel& operator << ( const std::string& ) const;
	const virtual SockChannel& operator >> ( std::string& ) const;
	const Glib::RefPtr<Glib::IOChannel> getChannel();
	int sendCommand(const char *fmt, ...);
protected:
	unsigned int trid;
	Glib::RefPtr<Glib::IOChannel> channel;
};


#endif /* _SOCKCHANNEL_H */
