/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "global.h"
#include <gtkmm/main.h>
#include <glibmm/ustring.h>
#include <map>

std::map<const unsigned int, GroupInfo> group;
std::map<const std::string, BuddyInfo> buddy;
UserInfo userinfo;
LoginWindow* loginwindow;
MainWindow* mainwindow;

bool 
on_mainwindow_delete_event(GdkEventAny *event)
{
	std::cout << "mainwindow end" << std::endl;
	//TODO:
	//
	// use systemtray
	gtk_main_quit();
	return true;
}

bool 
on_loginwindow_delete_event(GdkEventAny *event, LoginWindow** loginwindow)
{
	delete *loginwindow;
	std::cout << "loginwindow end" << std::endl;
	return true;
}

int 
main(int argc, char **argv)
{  
#if defined(ENABLE_NLS)
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
#endif
	
	Glib::thread_init();
	Gtk::Main main_instance(&argc, &argv);
	
	mainwindow = new MainWindow();
	mainwindow->signal_delete_event().connect(SigC::slot(&on_mainwindow_delete_event));
	loginwindow = new LoginWindow();
	loginwindow->signal_delete_event().connect(SigC::bind<LoginWindow**>(SigC::slot(&on_loginwindow_delete_event), &loginwindow));
	
	//if autologin
	// set userinfo's id and password
	/*
	userinfo.id = "";
	userinfo.password = "";
	loginwindow->connect();
	*/
	//else 
	loginwindow->show();
	
	main_instance.run();
	
	return 0;
}
