/*
 *  Copyright  2004  Day Choi <eo1120@yahoo.co.kr>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GLOBAL_H
#define _GLOBAL_H

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif

#include "BuddyModel.h"
#include "ChatWindow.h"
#include "LoginWindow.h"
#include "MainWindow.h"
#include "SockChannel.h"
#include "SSLSockChannel.h"
#include <config.h>

/*
 * Standard gettext macros.
 */

#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (GETTEXT_PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

#define MSN_DISPATCH_SERVER_ADDRESS "messenger.hotmail.com"
#define MSN_DISPATCH_SERVER_PORT 1863
#define MSN_PASSPORT_SERVER_ADDRESS "nexus.passport.com"
#define MSN_PASSPORT_SERVER_PORT 443
#define MSN_MAX_BUF_LEN 5000

enum {FLN,NLN,IDL,BSY,AWY,PHN,LUN,BRB};

typedef struct __user_info UserInfo;
	
struct __user_info {
	std::string id;
	std::string password;
	std::string nick;
	std::string ssl_login_path;
	std::string ssl_login_host;
	GHashTable* ssl_challenge_data;
};	

extern Glib::RefPtr<Gdk::Pixbuf> buddyimage[8];
extern Glib::RefPtr<Gdk::Pixbuf> statusimage[8];

extern std::map<const unsigned int, GroupInfo> group;
extern std::map<const std::string, BuddyInfo> buddy;

extern UserInfo userinfo;
extern LoginWindow* loginwindow;
extern MainWindow* mainwindow;

#endif /* _GLOBAL_H */
